package com.iformall.controller.msg;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.BaseEntity;
import com.iformall.domain.po.WxMsgCallback;
import com.iformall.service.WxMsgCallbackService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
@RequestMapping("msgCallback")
public class WxMsgCallbackController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMsgCallbackService wxMsgCallbackService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "短信回调结果-列表")
    public ResultData list(@ModelAttribute WxMsgCallback wxMsgCallback, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMsgCallbackController::list");
        if (null == wxMsgCallback) wxMsgCallback = new WxMsgCallback();
        wxMsgCallback.setTenantId(getTenantId());
        wxMsgCallback.setSortColumns(BaseEntity.SortField.Createtime_DESC);
        final PageInfo<WxMsgCallback> page = wxMsgCallbackService.listAsPage(wxMsgCallback, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "短信回调结果-新增")
    public ResultData add(@RequestBody WxMsgCallback wxMsgCallback) {
        logger.debug("[" + getIpAddr() + "] WxMsgCallbackController::add");
        //Assert.notNull(wxMsgCallback.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxMsgCallback.setTenantId(getTenantId());
        wxMsgCallbackService.saveOrUpdate(wxMsgCallback);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "短信回调结果-更新")
    public ResultData update(@RequestBody WxMsgCallback wxMsgCallback) {
        logger.debug("[" + getIpAddr() + "] WxMsgCallbackController::update");
        wxMsgCallbackService.saveOrUpdate(wxMsgCallback);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "短信回调结果-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgCallbackController::delete");
        wxMsgCallbackService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "短信回调结果-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMsgCallbackController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMsgCallbackService.getById(id));
    }
}
